import {Component, ViewEncapsulation} from 'angular2/core';
import {ROUTER_DIRECTIVES, RouteConfig, Router, AsyncRoute, RouteDefinition} from 'angular2/router';
import {ControlListService} from './services/control-list.service';
import {NorthwindService} from './services/northwind.service';
import * as menu from './components/menu/default.component';


function AsyncRoutes(params: Array<any>): Array<RouteDefinition> {
    var maps = {}, locations = {};
    maps[params[0].path] = params[0].name;
    locations[params[0].path] = params[0].location;
    for (var i = 1; i < params.length; i++) {
        var element = params[i];
        maps[params[i].path] = params[i].name;
        locations[params[i].path] = params[i].location;
        params[i] = new AsyncRoute({
            path: element.path,
            loader: function(element) { return () => System.import(element.location).then(m => m[element.component]) } (element),
            name: element.name
        })
    }
    setTimeout(function() {
        AppComponent.Routers = maps;
        AppComponent.Locations = locations;
    }, 0);

    return params;
}

@Component({
    selector: 'ej-app',
    viewProviders: [ControlListService,NorthwindService],
    templateUrl: 'app/app.component.html',
    encapsulation: ViewEncapsulation.None,
    directives: [ROUTER_DIRECTIVES]
})
@RouteConfig(AsyncRoutes([
    { path: '/', name: 'Menu', component: menu.DefaultComponent, location: 'app/components/menu/menu.component' },
   
]))
export class AppComponent {
    routeName: any;
    location: any;
    constructor(public router: Router) {
        this.router.subscribe((val) => {
            this.routeName = AppComponent.Routers['/' + val];
            this.location = AppComponent.Locations['/' + val];
        });
    }
   
    static Routers: Object;
    static Locations: Object;
}