import {provide, enableProdMode, ExceptionHandler} from 'angular2/core';
import {bootstrap} from 'angular2/platform/browser';
import {AppComponent} from './app.component';
import {ROUTER_PROVIDERS, APP_BASE_HREF, Location, LocationStrategy, HashLocationStrategy} from 'angular2/router';

enableProdMode();

class MyExceptionHandler implements ExceptionHandler {
  call(error, stackTrace = null, reason = null) {
    console.log(error + "\n" + stackTrace);
  }
}

bootstrap(AppComponent, [
  ROUTER_PROVIDERS,
  provide(APP_BASE_HREF, {useValue: '/'}),
  provide(LocationStrategy, {useClass: HashLocationStrategy}),
  provide(ExceptionHandler, {useClass: MyExceptionHandler})
]);